;FILE: M0.ASM
;
;THIS PROGRAM TRANSMITS THE HEX VALUE AA REPETITIVELY ACCROSS THE SERIAL PORT 
;OF A MCS-51 MICROCONTROLLER IN MODE 0
;
;DETAILS:
;
;MODE 0: SERIAL DATA EXITS AND ENTERS THROUGH THE RXD PIN.  THE TXD PIN OUTPUTS 
;THE SHIFT CLOCK.  IN MODE 0, 8 BITS ARE TRANSMITTED/RECEIVED STARTING WITH THE 
;LEAST SIGNIFICANT BIT.  THE BAUD RATE IS FIXED TO 1/12 THE OSCILLATOR FREQUENCY.
;
;
	ORG 00H
;
	JMP MAIN
MAIN:   MOV SCON,#00H                            ;SET UP FOR MODE 0
	CLR TI                                   ;READY TO TRANSMIT
LOOP:   MOV SBUF,#0AAH                           ;TRANSMIT AAH
	JNB TI,$                                 ;WAIT FOR END OF TRANSMISSION
	CLR TI                                   ;CLEAR TRANSMIT FLAG
	JMP LOOP                                 ;DO IT ALL AGAIN
	END
